<template>
  <div>
    <div class="preorder-header" v-if="account && !account.fromApp">
      <h1 class="page-title">{{ $t("preorderRecords.title") }}</h1>
    </div>

    <div class="preorder-body container">
      <div class="hello-message" v-if="account && !account.fromApp">
        <hello-member></hello-member>
      </div>

      <div class="tabs">
        <div :class="tabClasses('pickUp')" @click="tab = 'pickUp'">
          {{
            $t("preorderRecords.pickUpRecords", { count: pickUpOrders.length })
          }}
        </div>
        <div :class="tabClasses('delivery')" @click="tab = 'delivery'">
          {{
            $t("preorderRecords.deliverRecords", {
              count: deliverOrders.length
            })
          }}
        </div>
      </div>

      <div class="list">
        <record-list
          @reload="loadData"
          :loading="loading"
          :records="tabOrders"
          :type="tab"
        />
      </div>

      <div class="record-count">
        {{
          $t("preorderRecords.total", {
            count: tab === "pickUp" ? pickUpOrders.length : deliverOrders.length
          })
        }}
      </div>
    </div>
  </div>
</template>

<script>
import * as Api from "@/api";
import { mapState, mapGetters, mapActions } from "vuex";
import HelloMember from "@/components/HelloMember";
import RecordList from "@/components/Preorder/RecordList";

export default {
  data() {
    return {
      tab: "pickUp",
      order: null,
      orders: [],
      pickUpOrders: [],
      deliverOrders: [],
      loading: false
    };
  },

  components: {
    HelloMember,
    RecordList
  },

  computed: {
    ...mapGetters("routes", ["updatedTime"]),
    ...mapState("account", ["account"]),

    tabOrders() {
      return this.tab === "pickUp" ? this.pickUpOrders : this.deliverOrders;
    }
  },

  watch: {
    updatedTime() {
      this.loadData();
    },
    account() {
      if (this.account && this.account.id) {
        this.loadData();
      }
    }
  },

  methods: {
    ...mapActions("account", ["fetchAccount"]),
    tabClasses(tab) {
      var classes = "tab";
      if (this.tab === tab) {
        classes += " active";
      }
      return classes;
    },

    async loadData() {
      this.loading = true;
      const orders = await Api.Accounts.getOrders(this.account.id);
      this.pickUpOrders = orders.TakeOutList || [];
      this.deliverOrders = orders.DeliveryList || [];
      this.orders = orders || [];
      this.loading = false;
    }
  },

  mounted() {
    if (this.account && this.account.id) {
      this.loadData();
    }
  }
};
</script>

<style lang="scss" scoped>
.preorder-header {
  position: relative;
  height: 120px;
  text-align: center;
  color: #ffffff;
  background-image: url("/static/images/records-header.png");
  background-size: cover;

  &::before {
    content: "";
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    background: rgba(0, 0, 0, 0.3);
    z-index: 0;
  }
}

.page-title {
  margin: 0;
  padding: 0;
  font-size: 30px;
  font-weight: 500;
  line-height: 120px;
  z-index: 1;
  position: relative;
}

.preorder-body {
  margin: 0 auto;
  padding: 0 20px;
}

.hello-message {
  margin: 20px 0 20px 0;

  @include media-breakpoint-up(md) {
    margin-left: -20px;
  }
}

.tabs {
  display: flex;
  margin: 12px 0 6px;
  font-size: 14px;

  @include media-breakpoint-up(md) {
    display: block;
  }
}

.tab {
  position: relative;
  flex: 1 1 50%;
  color: $color-secondary-black;
  text-align: center;
  line-height: 44px;
  cursor: pointer;

  &:first-child::before {
    content: "";
    position: absolute;
    right: 0;
    top: 50%;
    width: 1px;
    height: 20px;
    margin-top: -10px;
    background: $color-sky-grey;
  }

  &.active {
    color: $color-skm-red;
    font-weight: 500;
  }

  @include media-breakpoint-up(md) {
    display: inline-block;
    padding: 0 30px;

    &:first-child {
      padding-left: 0;
    }
  }
}

.record-count {
  text-align: center;
  font-size: 13px;
  color: $color-secondary-black;
  margin: 16px 0 20px;
}

.preorder-body .list {
  overflow: scroll;
}
</style>
